
char greeting[] = "\n\nTCOUNT v3.2a for Doom 05/14/00\nThis is an ALPHA - check back for a new version soon";
char thingdatafile[] = "tcount3x.dat";

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <ctype.h>

#define tag_max 512
#define name_len 30


#ifdef __cplusplus

	int max (int value1, int value2);

	int max(int value1, int value2)
	{
		 return ( (value1 > value2) ? value1 : value2);
	}

#endif


FILE * datfile;
FILE * thingfile;
FILE * sumfile;
int testchar;
char stringhold[256];
int tnum = 0;
char tname[256];
int thealth;
int tarmor;
int tammo;
int tdamage;
int mdamage;
char t_text[5][2];


FILE *infile, *outfile;
char intext[80];
char strhold[10];
unsigned long num_dir_ents, dir_offset;
char ent_name[9];
int i,j,k;		

typedef struct
	{
	unsigned long res_offset;
	unsigned long res_length;
	char res_name[8];
	} dir_ent_stru;

dir_ent_stru dir_ent;


char *getsflag;
int thing;
int attr, atemp;
int lev1;
int lev2;
int lev3;
int levmulti;
int deaf;

char *diff[3] = { "1+2 ", " 3  ", " 4  " };

typedef struct
	{
	int tag;		
	char name[name_len];
	int health;
	int armor;
	int ammo;			
	int kpoints;	
	int mdamage;		
	int qty[3];	
	} tagname;

static tagname tag_names[tag_max];  

typedef struct
	{
	int tag;		
	char name[name_len];
	long health;
	long armor;
	long ammo;			
	long kpoints;	
	long mdamage;		
	long qty[3];	
	} total;

total totals[3];	

typedef struct
		{
		int thing_no;
		int count[5]; 
		} thing_struc;

thing_struc thing_list [tag_max];

int thing_count=0;      				
int thing_place;
int tag_count=0;									


#ifdef OLD_DOOM

typedef struct
	{
	int x_coord;
	int y_coord;
	int angle;
	int type;
	int attrib;
	} wad_thing;

#define zdoomFlagTranslate(x) (x & 0x1f)  /* boom bits are bad, mmkay? */

#else

/* effectively the reverse of zwadconv's ConvertThings, bitmasks
   ripped straight from the zwadconv source
*/

#define MTF_SINGLE               0x0100
#define MTF_COOPERATIVE          0x0200
#define MTF_DEATHMATCH           0x0400

#define BTF_NOTSINGLE            0x0010  /* (TF_COOPERATIVE|TF_DEATHMATCH)*/
#define BTF_NOTDEATHMATCH        0x0020  /* (TF_SINGLE|TF_COOPERATIVE)    */
#define BTF_NOTCOOPERATIVE       0x0040  /* (TF_SINGLE|TF_DEATHMATCH)     */


#define zdoomFlagTranslate(x) ((x & 0xf) | (x & MTF_SINGLE ? 0 : BTF_NOTSINGLE))

typedef struct
	{
	int thing_id;	
	int x_coord;	
	int y_coord;	
	int altitude;	
	int angle;		
	int type;		
	int attrib;		
        unsigned char spec_type; 
	unsigned char spec1;
	unsigned char spec2;
	unsigned char spec3;
	unsigned char spec4;
	unsigned char spec5;
        } wad_thing;


#endif

wad_thing w_thing;

int main(int argc, char **argv)
	{
	puts(greeting);






	if (_argc != 3)			
		{
		puts("Syntax:\n");
		puts("TCOUNT wadfile level     (for info on that level)");
		puts("TCOUNT wadfile /L        (for names of entries in wadfile)\n");
		puts("Examples:\n");
		puts("TCOUNT c:\\doom2\\doom2.wad map04");
		puts("TCOUNT c:\\doom\\doom.wad e3m7");
		puts("TCOUNT c:\\doom\\wads\\mywad.wad /L\n\n");
		exit(0);
		}

	
	infile = fopen(_argv[1],"rb");
	if (infile == NULL)
		{
		printf("Input File Open Error: %s\n\n", _argv[1]);
		exit(0);
		}
	printf("Opened file: %s\n\n", _argv[1]);
	strncpy(ent_name,strupr(_argv[2]),8);

	
	fseek(infile,4,SEEK_SET);
	fread(&num_dir_ents, sizeof(num_dir_ents), 1, infile);	
	fread(&dir_offset, sizeof(dir_offset), 1, infile);	

	
	fseek(infile, dir_offset, SEEK_SET);

	
	if ((_argv[2][0] == '/') && (toupper(_argv[2][1]) == 'L'))
		{
		for(i=0; i<num_dir_ents; i++)
			{
			fread(&dir_ent, sizeof(dir_ent_stru), 1, infile);	
			puts(dir_ent.res_name);
			}
		exit(0);
		}

	
	for (i=0; i<num_dir_ents; i++)
		{
		fread(&dir_ent, sizeof(dir_ent_stru), 1, infile);
		if (!strcmp(ent_name,strupr(dir_ent.res_name)))
			{
			puts("Level Address Found");
			
			for (j=0; j<10; j++)
				{
				fread(&dir_ent, sizeof(dir_ent_stru), 1, infile);
				if (!strcmpi(dir_ent.res_name, "THINGS")) goto analyse;
				}
			printf("THINGS entry not found in %s\n\n", ent_name);
			exit(0);
			}
		}
	printf("Entry %s not found\n\n", ent_name);
	exit(0);



analyse:		

	puts("THINGS Entry Found");

datfile = fopen(thingdatafile, "rt");
if (datfile == NULL)
	{
	printf("%s File Open Error\n\n", thingdatafile);
	exit(0);
	}
for (;;)
{
testchar = fgetc(datfile);
if (testchar == '!') break;
if (testchar == EOF)
	{
	printf("PREMATURE %s TERMINATION\N", thingdatafile);
	printf("Check that %s is terminated with a !\n\n", thingdatafile);
	exit(1);
	}
fseek(datfile, -1, SEEK_CUR);
if (testchar == '#')
	{
	
	fgets(stringhold, 255, datfile);
	}
	else
	{
	
	fgets(tname, 255, datfile);	
	if ( sscanf(tname, "%s", stringhold) <= 0) continue;  
	
	tnum = strlen(tname);
	tname[tnum-1] = 0x00;
	strncpy(tag_names[tag_count].name, tname, name_len-1);
	
	fgets(stringhold, 255, datfile);
	testchar = sscanf(stringhold,"%i %i %i %i %i",
		&tag_names[tag_count].tag,
		&tag_names[tag_count].health,
		&tag_names[tag_count].armor,
		&tag_names[tag_count].ammo,
		&tag_names[tag_count].kpoints);
	if (testchar != 5)
		{
		printf("BAD LINE READ IN TCOUNT.DAT %s", thingdatafile);
		puts(stringhold);
		exit(0);
		}
	tag_count++;
	}

}

fclose(datfile);






	strcpy(strhold, ent_name);
	strcat(strhold, ".txt");
	printf("Writing data to %s\n",strhold);
	outfile = fopen(strhold,"wt");
	if (outfile == NULL)
		{
		printf("Output File Open Error: %s\n\n", strhold);
		exit(0);
		}

	
	fseek(infile, dir_ent.res_offset,SEEK_SET);	


/* 	for (i=0;;i++)		
		{
		if (tag_names[i].tag == -9999)
			{
			tag_count = i-1;	
			break;
			}
		}
*/


/*	infile = fopen("things.lev","rt");
	getsflag = fgets(intext, 79, infile);	 */				

	thingfile = fopen("thingdat.txt","wt");
	if (outfile == NULL)
		{
		puts("Output File Open Error: THINGDAT.TXT\n\n");
		exit(0);
		}
	fputs(greeting, thingfile);

	fprintf(thingfile, "\n\nThing analysis of %s  Level: %s\n\n",
		_argv[1], _argv[2]);
	fputs("       XCOORD YCOORD  ANGLE   TYPE ATTRIB   |1+2| 3 | 4 | D | M |\n", thingfile);
	for(k=0; k<dir_ent.res_length/sizeof(w_thing); k++)
		{
		fread(&w_thing, sizeof(w_thing), 1, infile);

                w_thing.attrib = zdoomFlagTranslate(w_thing.attrib);

		lev1 = (w_thing.attrib)    & 0x01;
		lev2 = (w_thing.attrib>>1) & 0x01;
		lev3 = (w_thing.attrib>>2) & 0x01;
		deaf = (w_thing.attrib>>3) & 0x01;
		levmulti = (w_thing.attrib>>4) & 0x01;

		if (lev1)
			strcpy(t_text[0],"X");
		else
			strcpy(t_text[0]," ");

		if (lev2)
			strcpy(t_text[1],"X");
		else
			strcpy(t_text[1]," ");

		if (lev3)
			strcpy(t_text[2],"X");
		else
			strcpy(t_text[2]," ");

		if (deaf)
			strcpy(t_text[3],"X");
		else
			strcpy(t_text[3]," ");

		if (levmulti)
			strcpy(t_text[4],"X");
		else
			strcpy(t_text[4]," ");


		fprintf(thingfile,"%6i %6i %6i %6i %6i %6i   | %1s | %1s | %1s | %1s | %1s |", k, w_thing.x_coord,
			w_thing.y_coord, w_thing.angle, w_thing.type, w_thing.attrib,
			t_text[0], t_text[1], t_text[2], t_text[3], t_text[4]);
		if (levmulti == 1) fputs("  Multi", thingfile);
/*		fprintf(outfile, "%6i %6i %6i %6i %6i %6i %6i\n\n", thing, attr, lev1, lev2, lev3,
			deaf, levmulti); */
		fputs("\n", thingfile);
		if (levmulti == 1) continue;		

		thing_place = -1;		
		i=0;
		do
			{
			if (thing_list[i].thing_no == w_thing.type)
				{
				thing_place=i;	
				break;
				}
			i++;
			} while (i<thing_count);
		if (thing_place == -1)			
			{
			thing_place = thing_count;
			thing_count++;
			thing_list[thing_place].thing_no = w_thing.type;
			}

		thing_list[thing_place].count[1] = thing_list[thing_place].count[1] + lev1;
		thing_list[thing_place].count[2] = thing_list[thing_place].count[2] + lev2;
		thing_list[thing_place].count[3] = thing_list[thing_place].count[3] + lev3;
		thing_list[thing_place].count[4] = thing_list[thing_place].count[4] + levmulti;
		} 	
	fclose(infile);
	fclose(thingfile);




	fputs(greeting, outfile);
	fprintf(outfile, "\n\nDetailed Thing List of %s  Level: %s\n\n",
		_argv[1], _argv[2]);
	fputs("\n\n 1+2    3    4 PNTS   DESCRIPTION                   ",
		outfile);
	fputs(" HLTH ARMR AMMO THNG\n\n", outfile);
	for (i=0; i<=tag_count; i++)
		{
		for (j=0; j<thing_count; j++)
			{ 
			if (tag_names[i].tag == thing_list[j].thing_no)
				{
				k++;
				tag_names[i].qty[0] = thing_list[j].count[1];
				tag_names[i].qty[1] = thing_list[j].count[2];
				tag_names[i].qty[2] = thing_list[j].count[3];
				thing_list[j].count[0] = 1;	
				tag_names[i].mdamage = 1;		

				if (tag_names[i].name[0] != '*')
					{
					fprintf(outfile, "%4i %4i %4i %4i   %-30s %4i %4i %4i %4i\n",
						tag_names[i].qty[0],
						tag_names[i].qty[1],
						tag_names[i].qty[2],
						tag_names[i].kpoints,
						&tag_names[i].name,
						tag_names[i].health,
						tag_names[i].armor,
						tag_names[i].ammo,
						tag_names[i].tag);
					}
				}
			}
		}
	fputs("\f\n", outfile);	
	
	
	fputs("\n\nUnknowns\n\n", outfile);
	k=0;
	for (i=0; i<thing_count; i++)
		{
		if (thing_list[i].count[0] == 0)
			{
			fprintf(outfile, "Unknown Thing: %6i\n", thing_list[i].thing_no);
			k=1;
			}
		}
	if (k == 0) fputs("No Unknowns Found\n", outfile);


	
	for (i=1; i<tag_count; i++)
		{
		if (tag_names[i].mdamage != 0)
			{

			
			totals[0].health = totals[0].health +
				(long) (tag_names[i].health * tag_names[i].qty[0]);
			totals[1].health = totals[1].health +
				(long) (tag_names[i].health * tag_names[i].qty[1]);
			totals[2].health = totals[2].health +
				(long) (tag_names[i].health * tag_names[i].qty[2]);

			
			totals[0].armor = totals[0].armor +
				(long) (tag_names[i].armor * tag_names[i].qty[0]);
			totals[1].armor = totals[1].armor +
				(long) (tag_names[i].armor * tag_names[i].qty[1]);
			totals[2].armor = totals[2].armor +
				(long) (tag_names[i].armor * tag_names[i].qty[2]);

			
			totals[0].ammo = totals[0].ammo +
				(long) (tag_names[i].ammo * tag_names[i].qty[0]);
			totals[1].ammo = totals[1].ammo +
				(long) (tag_names[i].ammo * tag_names[i].qty[1]);
			totals[2].ammo = totals[2].ammo +
				(long) (tag_names[i].ammo * tag_names[i].qty[2]);

			
			totals[0].kpoints = totals[0].kpoints +
				(long) (tag_names[i].kpoints * tag_names[i].qty[0]);
			totals[1].kpoints = totals[1].kpoints +
				(long) (tag_names[i].kpoints * tag_names[i].qty[1]);
			totals[2].kpoints = totals[2].kpoints +
				(long) (tag_names[i].kpoints * tag_names[i].qty[2]);

			}
		}
	
	fprintf(outfile, "\n\n%s Totals by Difficulty:\n\n", _argv[2]);
	fputs("        HEALTH    ARMOR     AMMO   POINTS\n", outfile);
	for (i=0; i<3; i++)
		{
		fprintf(outfile, "%s  %8li %8li %8li %8li\n", diff[i], totals[i].health,
			totals[i].armor,totals[i].ammo, totals[i].kpoints);
		}
	
	fputs("\n\n\n\nRatios to POINTS by Difficulty:\n\n", outfile);
	fputs("          HEALTH      ARMOR       AMMO\n", outfile);
	for (i=0; i<3; i++)
		{
		fprintf(outfile, "%s  ", diff[i]);

		if (totals[i].kpoints == 0)
			{
			fputs("No points - Divide by 0 - Points total set to 1\n", outfile);
			totals[i].kpoints=1;
			}
		else
			fprintf(outfile,"%10.2f %10.2f %10.2f\n",
				(float) totals[i].health/totals[i].kpoints,
				(float) totals[i].armor/totals[i].kpoints,
				(float) totals[i].ammo/totals[i].kpoints);
		}

	fclose(outfile);

	
	strcpy(strhold, ent_name);
	strcat(strhold, ".sum");
	printf("Writing data to %s\n",strhold);
	sumfile = fopen(strhold,"wt");
	if (outfile == NULL)
		{
		printf("Summary File Open Error: %s\n\n", strhold);
		exit(0);
		}
	fputs("      ", sumfile);
	for (i=0; i<3; i++)
		{
		fputs("LVL  POINTS HEALTH  ARMOR   AMMO  HL/PT  AR/PT  AM/PT | ", sumfile);
		}
	fputs("\n", sumfile);

	fprintf(sumfile,"%-6s", _argv[2]);
	for (i=0; i<3; i++)
		{
		fprintf(sumfile, "%s %6li %6li %6li %6li %6.2f %6.2f %6.2f   ",
			diff[i],
			totals[i].kpoints,
			totals[i].health,
			totals[i].armor,
			totals[i].ammo,
			(float) totals[i].health/totals[i].kpoints,
			(float) totals[i].armor/totals[i].kpoints,
			(float) totals[i].ammo/totals[i].kpoints);
		}
	fputs("\n", sumfile);
	fclose(sumfile);
	}
